/*****************************************************

CodeWizardAVR V1.25.9 Professional  -   www.avr123.nm.ru

Project : m48_ac_chip
Version : 001
Date    : 21.01.2009
Author  : AVR123                        
Company : avr123.nm.ru                         

      - mc3phac   www.freescale.com
 ATmega48          .

 :

  3-      3- .

 -     amp_sin  0  255
   .

   PROTEUS  .  

================================================================================

Chip type           : ATmega48
Clock frequency     : 8 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128    
  
USART   8N1 38400    8 Data, 1 Stop, No Parity    

================================================================================

      3-  

 ""     PD6    OCR0A
 "B"     PD5    OCR0B
 "C"     PB3    OCR2A   

    !      PROTEUS    
                "A" - PD6     "B" - PB3      "C" - PD5

         
  74hc14 (. 15532)

   :    100 * (  )/255 

  0.5    128    
 3- .    - 43

=====================================================================

1   4 -        2   
 OCR1A   interrupt [TIM1_COMPA]     
  .

  : 

1)   PB0   . 

2)       
index_sin      inc_ind   
    3- .

..          
     3-  .
  
=====================================================================    
 !!!

     300  -   1   
300*256=76800   .    8   9600   .

 1   8,    OCR1A = 103; 
  9615,385   .  


  .   OCR1AH = 0xFF;  OCR1AL = 0xFE; 
 79132    12,64     ,   256
 - 0,049 .

=====================================================================

     .

================================================================================
 

  -   AVR ATmega 
     ATtiny   - www.AVR123.nm.ru

  . 
http://www.roboforum.ru/viewtopic.php?f=2&t=1070&p=11560#p11560

"  "       
avr123.nm.ru/05.htm  
avr123.nm.ru/05a.htm       

       
CVAVR  -          .
avr123.nm.ru         avr123.nm.ru/06.htm 

CVAVR  -      .      

; ************************************************************


      VMLAB 
(   www.amctools.com)  :
avr123.nm.ru/z2.htm
avr123.nm.ru/z3.htm
avr123.nm.ru/z9.htm

        VMLAB

; ************************************************************

  "-"    
  -   :  avr123.nm.ru/z4.htm

///////////////////////////////////////////////////////////////

//      - PROTEUS  !!! 
//    - http://www.oProteus.narod.ru
     
///////////////////////////////////////////////////////////////

  CVAVR 1.25.9       avr123.nm.ru    
 
  PROTEUS 7.4 sp4 PRO      
  http://www.roboforum.ru/viewtopic.php?f=2&t=2398 
  
*****************************************************/

// Declare your global variables here
volatile char ctr; 

// volatile unsigned char temp = 0; //  


volatile unsigned int index_sin = 0; //     

volatile unsigned char index_a_sin = 0; //   A    
volatile unsigned char index_b_sin = 85; //   B    
volatile unsigned char index_c_sin = 43; //   C   

volatile unsigned int temp_16; //   2 
volatile unsigned char temp_8; //   1 

volatile unsigned char temp_a; //     A
volatile unsigned char temp_b; //     B
volatile unsigned char temp_c; //     C

volatile unsigned char pol_a = 1; //   A  "1" -  126
volatile unsigned char pol_b = 1; //   B  "0" -  128 
volatile unsigned char pol_c = 0; //   C 

volatile unsigned char index_bc_calc = 1; // "1" -        

volatile unsigned char  inc_ind = 1;  //      

volatile unsigned int freq_int = 350; //   ,   103.

volatile unsigned char amp_sin = 0; //  . 255  .    

// volatile unsigned char error_table = 0; //    

// #define OCR1A (*(unsigned int *) 0x88) // 16 bit access
//       OCR1A

#include <mega48.h>
#include <delay.h>
#include <stdio.h> 
  
 
#include <sin256.h>
/*    flash unsigned char sinus[256]={ };

    3-   
     3- 

   0  255
 
*/
 


// Timer 1 output compare A interrupt service routine
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
//     TCNT1=OCR1A  

PORTB^=1; //    PB0  //debug

//          .  

ADCSRB = index_a_sin; //debug
        
//============================================ 
//                  
//index_a_sin += inc_ind;

//============================================ 
// . .     
if (index_a_sin > 127){ 
           index_a_sin -= 128;
     
     index_bc_calc = 0; //            
     
  if (pol_a){ //   
                   pol_a = 0; pol_b = 0; pol_c = 1;
     index_b_sin = index_a_sin + 85;
     index_c_sin = index_a_sin + 43; 
            }
    else{
                   pol_a = 1; pol_b = 1; pol_c = 0;
     index_b_sin = index_a_sin + 85;
     index_c_sin = index_a_sin + 43;
        } 
                      }        
                      

//============================================ 
//      B  C  
if (index_bc_calc) {  

//============================================
//   .   B  
if (index_b_sin > 127){ 
           index_b_sin -= 128;  
     
  if (pol_b){ //    B
               pol_b = 0; 
            }
    else{
                pol_b = 1; 
        } 
                      }


//============================================
//   .     
if (index_c_sin > 127){ 
           index_c_sin -= 128;  
     
  if (pol_c){ //    B
               pol_c = 0; 
            }
    else{
                pol_c = 1; 
        } 
                      }
}
//============================================

//          .
                   
//============================================
//     
ADCSRB = sinus[index_a_sin];  //debug

//      . amp_sin    .
temp_8 = (((unsigned int)amp_sin * (unsigned int)sinus[index_a_sin])) >> 8;
//    32  AVR

     ADCSRB = temp_8; //debug
     
if (pol_a){ //     
              temp_a = temp_8 + 127; // PWM PD6 Faza_A
          }
    else{   //     
              temp_a = 127 - temp_8;
        } 
             
//============================================
//    B 
ADCSRB = sinus[index_b_sin];  //debug

//      . amp_sin    .
temp_8 = (((unsigned int)amp_sin * (unsigned int)sinus[index_b_sin])) >> 8;
//    32  AVR

     ADCSRB = temp_8; //debug
     
if (pol_b){ //     
              temp_b = temp_8 + 127; // PWM PD6 Faza_A
          }
    else{   //     
              temp_b = 127 - temp_8;
        } 
            
//========================================================
//    C 
ADCSRB = sinus[index_c_sin];  //debug

//      . amp_sin    .
temp_8 = (((unsigned int)amp_sin * (unsigned int)sinus[index_c_sin])) >> 8;
//    32  AVR

     ADCSRB = temp_8; //debug
     
if (pol_c){ //     
              temp_c = temp_8 + 127; // PWM PD6 Faza_A
          }
    else{   //     
              temp_c = 127 - temp_8;
        } 
                                 
//=========================================================
//          
OCR0A = temp_a;  // PWM PD6 Faza_A   
OCR0B = temp_b;  // PWM PD5 Faza_B  
OCR2A = temp_c;  // PWM PB3 Faza_C 

//=========================================================
//              
index_a_sin += inc_ind;  //   PWM PD6 Faza_A   
index_b_sin += inc_ind;  //   PWM PD5 Faza_B  
index_c_sin += inc_ind;  //   PWM PB3 Faza_C

index_bc_calc = 1; //       

temp_8 = 0; //debug

}
//=========================================================         
                                
           
           
           
           
           
           
           
           
         
// ================================================================================
//     

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Place your code here 
//ctr++;

}

// Timer 0 output compare A interrupt service routine
interrupt [TIM0_COMPA] void timer0_compa_isr(void)
{
// Place your code here
//ctr++;

}

// Timer 0 output compare B interrupt service routine
interrupt [TIM0_COMPB] void timer0_compb_isr(void)
{
// Place your code here
//ctr++;

}

//      
// ================================================================================




void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize- 
CLKPR=0x80;  
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
          
DDRB.0 = 1; //  
        
// ============================================================= 
//  _0  - 2     ""  ""
// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 8000 kHz  
// Mode: Phase correct PWM top=FFh    15 686 Hz
// OC0A output: Non-Inverted PWM
// OC0B output: Non-Inverted PWM
TCCR0A=0xA1;
TCCR0B=0x01;
TCNT0=0x00;

//  _2  -     ""
// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 8000 kHz  
// Mode: Phase correct PWM top=FFh    15 686 Hz
// OC2A output: Non-Inverted PWM
// OC2B output: Disconnected
ASSR=0x00;
TCCR2A=0x81;
TCCR2B=0x01;
TCNT2=0x00;

//      50 %    

OCR0A=127; // PWM PD6 Faza_A   100 * OCR0A/255  ( %)
OCR0B=127; // PWM PD5 Faza_B   100 * OCR0B/255  ( %)
OCR2A=127; // PWM PB3 Faza_C   100 * OCR2A/255  ( %)

//   
DDRD|=(1<<5)|(1<<6); // PD5 PD6    0
DDRB|=(1<<3);        // PB3         2

//  PWM       
//             PROTEUS  
    
    
           
// =============================================================     
//TIMER1 initialize - prescale:8
// WGM: 4) CTC, TOP=OCRnA
// desired value: 9600Hz
// actual value: 9615,385Hz   OCR1A = 103;

 TCCR1B = 0x00; //stop 
 
 //TCNT1H = 0xFF; //setup
 //TCNT1L = 0x99;
 
 //    8    PROTEUS
 OCR1AH = (unsigned char)(freq_int >> 8);
 OCR1AL = (unsigned char)freq_int;
 
 //OCR1BH = 0x00;
 //OCR1BL = 0x67;
 
 //ICR1H  = 0x00;
 //ICR1L  = 0x67;   
 
 TCCR1A = 0x00;
 TCCR1B = 0x0A; //start Timer
   
       
// ============================================================= 
// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// Interrupt on any change on pins PCINT0-7: Off
// Interrupt on any change on pins PCINT8-14: Off
// Interrupt on any change on pins PCINT16-23: Off
EICRA=0x00;
EIMSK=0x00;
PCICR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x07;

// Timer/Counter 1 Interrupt(s) initialization
TIMSK1=0x02;

// Timer/Counter 2 Interrupt(s) initialization
TIMSK2=0x00;
   

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: Off
// USART Transmitter: On
// USART0 Mode: Asynchronous
// USART Baud Rate: 38400        8 MHz
UCSR0A=0x00;
UCSR0B=0x08;
UCSR0C=0x06;
UBRR0H=0x00;
UBRR0L=0x0C;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
ADCSRB=0x00;

// Global enable interrupts
#asm("sei")

while (1)
      {
      // Place your code here 
                                  
 //   amp_sin = 250; //debug   
         
//    

 while (ctr < 254){  
 
 delay_ms(3);   
 
 amp_sin = ctr ++;
 
 };
 
 
 while (ctr){ 
 
 delay_ms(3);   
 
 amp_sin = ctr --;
 
 };
 
 
  

      };
}



